/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Series } from "./Series";
import { ISupportsFillScale_$type } from "./ISupportsFillScale";
import { DependencyProperty } from "igniteui-react-core";
import { BrushScale } from "./BrushScale";
import { HighlightingInfo } from "igniteui-react-core";
import { ShapeItemSearchMode_$type } from "./ShapeItemSearchMode";
import { IEnumerable$1_$type, String_$type, enumGetBox, Number_$type, Point_$type, typeCast, runOn, delegateCombine, fromEnum, Array_$type, markType, markDep } from "igniteui-react-core";
import { NumericXAxis } from "./NumericXAxis";
import { NumericYAxis } from "./NumericYAxis";
import { List$1 } from "igniteui-react-core";
import { Rect } from "igniteui-react-core";
import { StyleShapeEventArgs } from "./StyleShapeEventArgs";
import { FrameworkElement } from "igniteui-react-core";
import { IFastItemsSource_$type } from "igniteui-react-core";
import { DataContext } from "igniteui-react-core";
import { Tuple$2 } from "igniteui-react-core";
import { ShapeHitRegion } from "./ShapeHitRegion";
import { RectUtil } from "igniteui-react-core";
import { Tuple$3 } from "igniteui-react-core";
import { GeometryUtil } from "igniteui-react-core";
import { AssigningShapeStyleEventArgs } from "./AssigningShapeStyleEventArgs";
import { AssigningShapeMarkerStyleEventArgs } from "./AssigningShapeMarkerStyleEventArgs";
import { SeriesLayerPropertyOverlay } from "./SeriesLayerPropertyOverlay";
import { CustomPaletteBrushScale } from "./CustomPaletteBrushScale";
import { ValueBrushScale } from "./ValueBrushScale";
import { PointCollectionUtil } from "igniteui-react-core";
import { FlattenedShape } from "./FlattenedShape";
import { SeriesView } from "./SeriesView";
import { Clipper } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { Dictionary$2 } from "igniteui-react-core";
import { ActualRange } from "./ActualRange";
import { SeriesRenderManager } from "./SeriesRenderManager";
import { PolySimplification } from "igniteui-react-core";
import { DefaultFlattener } from "./DefaultFlattener";
import { ChartSelection } from "./ChartSelection";
import { AxisRange } from "./AxisRange";
import { Style } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { boxArray$1 } from "igniteui-react-core";
import { InvalidOperationException } from "igniteui-react-core";
import { isNaN_, truncate } from "igniteui-react-core";
import { FastItemObjectColumn } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { PointCollection } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PolyLineSegment } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { PolygonUtil } from "igniteui-react-core";
/**
 * @hidden
 */
export let ShapeSeriesBase = /*@__PURE__*/ (() => {
    class ShapeSeriesBase extends Series {
        constructor() {
            super();
            this.xr = null;
            this.xw = false;
            this.xv = false;
            this.xp = null;
            this.xq = null;
            this.xf = 1;
            this.w0 = null;
            this.w1 = null;
            this.assigningShapeStyle = null;
            this.assigningShapeMarkerStyle = null;
            this.xj = null;
            this.xs = null;
            this.xb = null;
            this.xd = null;
            this.yi = 0;
            this.ye = null;
            this.wx = null;
            this.wz = null;
            this.wy = null;
            this.ww = null;
            this.z2 = null;
            this.w9 = null;
            this.xl = null;
            this.w4 = null;
            this.yl = 0;
            this.styleShape = null;
            this.xj = new ShapeSeriesRenderManager();
            FastItemObjectColumn.m();
            this.yl = this.yk;
            this.z2 = Rect.empty;
        }
        o2() {
            super.o2();
            this.xc = null;
            this.xe = null;
        }
        ai() {
            return [this.xc, this.xe];
        }
        kq(a, b) {
            let c = this.nd(b);
            if (c == ShapeSeriesBase.$$p[9]) {
                return this.kr(a, b, this.y5);
            }
            return null;
        }
        md(a) {
            let b = this.nd(a);
            if (b == ShapeSeriesBase.$$p[9]) {
                return this.y5;
            }
            return super.md(a);
        }
        get xt() {
            return this.xr;
        }
        set xt(a) {
            if (this.xr != a) {
                let b = this.xt;
                this.xr = a;
                this.raisePropertyChanged("FillColumn", b, this.xt);
            }
        }
        get_fe() {
            return true;
        }
        get_ed() {
            return true;
        }
        xn(a, b, c) {
            if (this.dn == null) {
                return null;
            }
            let d = this.v5(b);
            let e = this.xk.c2(d, false);
            let f = -1;
            if (e == null) {
                if (a != null) {
                    f = this.dn.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else if (e.dataContext != null) {
                f = e.dataContext.c;
            }
            if (f == -1) {
                return null;
            }
            let g = new HighlightingInfo();
            g.i = this;
            g.g = f;
            g.f = f;
            g.c = false;
            if (c != null && c.g == g.g && c.f == g.f) {
                return c;
            }
            return g;
        }
        xo(a, b, c) {
            if (this.dn == null) {
                return null;
            }
            let d = this.xk.b4(this.v5(b));
            let e = -1;
            if (d == null) {
                if (a != null) {
                    e = this.dn.indexOf(a);
                }
                else {
                    return null;
                }
            }
            else {
                e = d.ak;
            }
            if (e == -1) {
                return null;
            }
            let f = new HighlightingInfo();
            f.i = this;
            f.g = e;
            f.f = e;
            f.c = false;
            f.d = true;
            if (c != null && c.g == f.g && c.f == f.f) {
                return c;
            }
            return f;
        }
        get xg() {
            return this.xf;
        }
        set xg(a) {
            let b = this.xf;
            this.xf = a;
            if (b != this.xf) {
                this.raisePropertyChanged("ActualItemSearchMode", enumGetBox(ShapeItemSearchMode_$type, b), enumGetBox(ShapeItemSearchMode_$type, this.xf));
            }
        }
        xh() {
            if (this.xi != 0) {
                return this.xi;
            }
            return 1;
        }
        ir(a) {
            switch (this.xg) {
                case 1: return this.zb(a).c;
                case 2: return this.yj(a);
                case 3: return this.yj(a);
            }
            return -1;
        }
        zb(a) {
            let b = this.v5(a);
            let c = { $type: Point_$type, x: NaN, y: NaN };
            let d = this.xk.ce;
            if (d == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let e = this.xk.b5(b, false, !this.xy);
            if (e != null) {
                c = RectUtil.l(e.d);
                return new Tuple$2(Number_$type, Point_$type, e.b, c);
            }
            let f = b.x;
            let g = b.y;
            if (this.dn == null || this.xc == null || this.xe == null || this.ye == null) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            if (this.dn.count > this.yo) {
                return new Tuple$2(Number_$type, Point_$type, -1, c);
            }
            let h = 1.7976931348623157E+308;
            let i = -1;
            for (let j = 0; j < d.count; j++) {
                let k = d._inner[j].d;
                let l = RectUtil.g(k, b);
                if (l < h) {
                    h = l;
                    i = d._inner[j].b;
                    c = RectUtil.l(d._inner[j].d);
                }
            }
            return new Tuple$2(Number_$type, Point_$type, i, c);
        }
        za(a) {
            let b = this.v5(a);
            let c = b.x;
            let d = b.y;
            let e = { $type: Point_$type, x: NaN, y: NaN };
            if (this.dn == null || this.xc == null || this.xe == null || this.ye == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            if (this.dn.count > this.yo) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let f = 1.7976931348623157E+308;
            let g = this.xk.ce;
            if (g == null) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
            }
            let h = this.xk.b5(b, false, !this.xy);
            if (h != null) {
                let i = RectUtil.l(h.d);
                let j = this.y9(b, h.a, this.xy);
                return new Tuple$3(Number_$type, Point_$type, Point_$type, h.b, j.d, i);
            }
            for (let k = 0; k < g.count; k++) {
                let l = g._inner[k].d;
                let m = RectUtil.g(l, b);
                let n = (l.width * l.width) + (l.height * l.height) + m;
                if (n <= f) {
                    f = n;
                }
            }
            let o = 1.7976931348623157E+308;
            let p = -1;
            for (let q = 0; q < g.count; q++) {
                let r = g._inner[q].d;
                let s = RectUtil.g(r, b);
                if (s < f) {
                    let t = this.y9(b, g._inner[q].a, this.xy);
                    if (t.c < o) {
                        o = t.c;
                        e = t.d;
                        p = q;
                    }
                }
            }
            if (p >= 0) {
                return new Tuple$3(Number_$type, Point_$type, Point_$type, g._inner[p].b, e, RectUtil.l(g._inner[p].d));
            }
            return new Tuple$3(Number_$type, Point_$type, Point_$type, -1, e, e);
        }
        get_xy() {
            return true;
        }
        get xy() {
            return this.get_xy();
        }
        y9(a, b, c) {
            let d = { $type: Point_$type, x: NaN, y: NaN };
            let e = 1.7976931348623157E+308;
            let f = { $type: Point_$type, x: NaN, y: NaN };
            let g = false;
            let h = -1;
            for (let i = 0; i < b.count; i++) {
                let j = b._inner[i];
                if (i >= 1) {
                    let k = GeometryUtil.h(a, d, j);
                    if (k < e) {
                        e = k;
                        g = true;
                        h = i;
                    }
                }
                d = j;
            }
            if (c) {
                let l = b._inner[0];
                let m = GeometryUtil.h(a, d, l);
                if (m < e) {
                    e = m;
                    let n = GeometryUtil.m(a, d, l);
                    f = { $type: Point_$type, x: d.x + (l.x - d.x) * n, y: d.y + (l.y - d.y) * n };
                    return new Tuple$2(Number_$type, Point_$type, e, f);
                }
            }
            if (g) {
                let o = b._inner[h - 1];
                let p = b._inner[h];
                let q = GeometryUtil.m(a, o, p);
                f = { $type: Point_$type, x: o.x + (p.x - o.x) * q, y: o.y + (p.y - o.y) * q };
            }
            return new Tuple$2(Number_$type, Point_$type, e, f);
        }
        yj(a) {
            return this.za(a).c;
        }
        wa(a, b, c) {
            if (this.xc == null || this.xe == null || this.ye == null) {
                return { $type: Point_$type, x: NaN, y: NaN };
            }
            switch (this.xg) {
                case 1:
                    let d = this.zb(a);
                    return d.d;
                case 2:
                    let e = this.za(a);
                    return e.e;
                case 3:
                    let f = this.za(a);
                    return f.d;
            }
            return { $type: Point_$type, x: NaN, y: NaN };
        }
        kn(a) {
            let b = this.j3(a);
            if (this.dn != null && b >= 0 && b < this.dn.count) {
                return this.dn.item(b);
            }
            return null;
        }
        xm(a, b, c) {
            let d = new HighlightingInfo();
            d.i = this;
            d.g = 0;
            d.f = this.dn.count - 1;
            d.c = true;
            if (c != null && c.g == d.g && c.f == d.f) {
                return c;
            }
            return d;
        }
        dg(a, b, c) {
            if (this.ed && this.fz(this.bx) && !c) {
                let d = this.xn(a, b, this.xp);
                this.xp = d;
                return d;
            }
            else {
                let e = this.xm(a, b, this.xp);
                this.xp = e;
                return e;
            }
        }
        dh(a, b, c) {
            if (this.fz(this.bx) && !c) {
                let d = this.xo(a, b, this.xq);
                this.xq = d;
                return d;
            }
            else {
                let e = this.xm(a, b, this.xq);
                e.d = true;
                this.xq = e;
                return e;
            }
        }
        yc() {
            return (this.assigningShapeStyle != null && this.xw) || this.d2 || (this.bx != 1) || (this.cp != 1) || (this.co != 1) || (this.xt != null && this.w8 != null);
        }
        yb() {
            return (this.assigningShapeMarkerStyle != null && this.xv) || this.d2 || (this.bx != 1) || (this.cp != 1) || (this.co != 1);
        }
        get yw() {
            return this.c(ShapeSeriesBase.zs);
        }
        set yw(a) {
            this.h(ShapeSeriesBase.zs, a);
        }
        gb() {
            return this.highlightedItemsSource != null || this.yw != null;
        }
        ht() {
            let a = super.ht();
            {
                let b = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.ad = "ShapeMemberPath";
                    $ret.p = true;
                    $ret.y = "HighlightedShapeMemberPath";
                    $ret.q = true;
                    return $ret;
                })());
                b.valueResolving = delegateCombine(b.valueResolving, runOn(this, this.ze));
                a.add(b);
            }
            {
                let c = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Brush";
                    $ret.p = true;
                    $ret.y = "ActualBrush";
                    $ret.q = true;
                    return $ret;
                })());
                c.valueResolving = delegateCombine(c.valueResolving, runOn(this, this.ry));
                a.add(c);
            }
            {
                let d = ((() => {
                    let $ret = new SeriesLayerPropertyOverlay();
                    $ret.r = true;
                    $ret.ad = "Outline";
                    $ret.p = true;
                    $ret.y = "ActualOutline";
                    $ret.q = true;
                    return $ret;
                })());
                d.valueResolving = delegateCombine(d.valueResolving, runOn(this, this.ry));
                a.add(d);
            }
            return a;
        }
        ze(a, b) {
            if (this.yw != null) {
                b.value = this.yw;
                return;
            }
            b.value = this.y5;
        }
        get xu() {
            return this.xs;
        }
        set xu(a) {
            let b = this.xu != a;
            if (b) {
                let c = this.xu;
                this.xs = a;
                this.raisePropertyChanged("ShapeColumn", c, this.xu);
            }
        }
        x3(array_) {
            let a = (Array.isArray(array_));
            return a;
        }
        static x7(a) {
            if (a == null) {
                return true;
            }
            let val_ = a;
            return (val_ == undefined);
        }
        convertToListList(a) {
            if (a == null) {
                return null;
            }
            let b = new List$1(List$1.$.specialize(Point_$type), 0);
            let c;
            let curr_;
            let d;
            let e;
            let f = false;
            let g = false;
            for (let h = 0; h < a.length; h++) {
                c = a[h];
                if (c == null) {
                    continue;
                }
                let i = new List$1(Point_$type, 0);
                for (let j = 0; j < c.length; j++) {
                    curr_ = c[j];
                    if (f) {
                        d = (curr_.X);
                        e = (curr_.Y);
                    }
                    else {
                        d = (curr_.x);
                        e = (curr_.y);
                    }
                    if (!g) {
                        if ((isNaN_(d) || ShapeSeriesBase.x7(d)) && (isNaN_(e) || ShapeSeriesBase.x7(e))) {
                            d = (curr_.X);
                            e = (curr_.Y);
                            if (!isNaN_(d) && !ShapeSeriesBase.x7(d) && !isNaN_(e) && !ShapeSeriesBase.x7(e)) {
                                g = true;
                                f = true;
                            }
                        }
                        else {
                            g = true;
                        }
                    }
                    i.add({ $type: Point_$type, x: d, y: e });
                }
                b.add(i);
            }
            return b;
        }
        dm(a) {
            if (this.dn != null && this.x3(this.itemsSource) && a != null && a.split('!').length != 2) {
                if (this.coercionMethods == null) {
                    this.coercionMethods = {};
                }
                let methods_ = this.coercionMethods;
                methods_.convertToListList = this.convertToListList;
                a += "!convertToListList";
            }
            return super.dm(a);
        }
        q7(a, b, c, d) {
            super.q7(a, b, c, d);
            let e = false;
            let f = false;
            switch (b) {
                case ShapeSeriesBase.$$p[5]:
                    this.xg = this.xh();
                    break;
                case "FastItemsSource":
                    let g = typeCast(IFastItemsSource_$type, c);
                    if (g != null) {
                        if (this.xt != null) {
                            g.deregisterColumn(this.xt);
                        }
                        if (this.xu != null) {
                            g.deregisterColumn(this.xu);
                        }
                        this.xu = null;
                    }
                    let h = typeCast(IFastItemsSource_$type, d);
                    if (h != null) {
                        if (this.y5 != null) {
                            this.xu = this.dm(this.y5);
                        }
                        if (this.ys != null) {
                            this.xt = this.dk(this.ys);
                        }
                    }
                    e = this.xc != null && !this.xc.c1();
                    f = this.xe != null && !this.xe.c1();
                    if (e || f) {
                        this.rp(this.gg && c != null);
                    }
                    break;
                case ShapeSeriesBase.$$p[9]:
                    if (this.dn != null) {
                        this.dn.deregisterColumn(this.xu);
                        this.xu = this.dm(this.y5);
                    }
                    break;
                case "ShapeColumn":
                    this.zm();
                    e = this.xc != null && !this.xc.c1();
                    f = this.xe != null && !this.xe.c1();
                    if (e || f) {
                        this.rp(this.gg && this.d7);
                    }
                    this.qj();
                    break;
                case ShapeSeriesBase.$$p[10]:
                case ShapeSeriesBase.$$p[11]:
                    this.xb = this.xc;
                    this.xd = this.xe;
                    let i = c;
                    let j = d;
                    this.zn(i);
                    this.zf(j);
                    if ((j != null && !j.c1()) || (j == null && i != null)) {
                        this.rp(false);
                    }
                    this.qj();
                    break;
                case "ActualResolution":
                    this.yi = this.id;
                    this.qj();
                    break;
                case "ActualBrush":
                    this.rp(false);
                    break;
                case ShapeSeriesBase.$$p[8]:
                    this.yl = this.yk;
                    this.rp(false);
                    this.qj();
                    break;
                case ShapeSeriesBase.$$p[2]:
                case "ActualThickness":
                    this.rp(false);
                    this.qj();
                    break;
                case ShapeSeriesBase.$$p[4]:
                    this.xw = this.ya();
                    this.rp(false);
                    break;
                case ShapeSeriesBase.$$p[3]:
                    this.xv = this.x9();
                    this.rp(false);
                    break;
                case ShapeSeriesBase.$$p[1]:
                    if (c != null) {
                        c.o.remove(this);
                        c.x();
                        this.w9 = null;
                        this.xl = null;
                    }
                    if (d != null) {
                        d.o.add(this);
                        d.x();
                        this.w9 = typeCast(CustomPaletteBrushScale.$, d);
                        this.xl = typeCast(ValueBrushScale.$, d);
                    }
                    this.rp(false);
                    this.qj();
                    break;
                case "FillColumn":
                    this.rp(this.gg && this.d7);
                    this.qj();
                    break;
                case ShapeSeriesBase.$$p[0]:
                    if (this.w8 != null) {
                        this.w8.x();
                    }
                    if (this.dn != null) {
                        this.dn.deregisterColumn(this.xt);
                        this.xt = this.dk(this.ys);
                    }
                    break;
            }
        }
        ya() {
            return this.x6;
        }
        x9() {
            return this.x5;
        }
        x0(a) {
            if (typeCast(NumericYAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        xz(a) {
            if (typeCast(NumericXAxis.$, a) !== null) {
                return true;
            }
            return false;
        }
        zm() {
            this.ye = null;
            if (this.xu == null) {
                return;
            }
            this.ye = new List$1(Rect.$, 2, this.xu.count);
            for (let a = 0; a < this.xu.count; a++) {
                this.ye.add(PointCollectionUtil.j(this.xu.item(a)));
            }
        }
        z3(a) {
            if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), a) !== null) {
                return PointCollectionUtil.h(a);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), a) !== null) {
                return PointCollectionUtil.g(a);
            }
            return Rect.empty;
        }
        yg(a, b, c, d, e, f, g) {
            return this.yh(a, b, c, d, e, f, g);
            if (typeCast(List$1.$.specialize(List$1.$.specialize(Point_$type)), c) !== null) {
                return this.yh(a, b, c, d, e, f, g);
            }
            else if (typeCast(IEnumerable$1_$type.specialize(IEnumerable$1_$type.specialize(Point_$type)), c) !== null) {
                let h = c;
                let i = new List$1(FlattenedShape.$, 0);
                let j = null;
                for (let k of fromEnum(h)) {
                    j = this.xa(a, b, PointCollectionUtil.b(k), d, e, f, g);
                    if (j == null) {
                        continue;
                    }
                    i.add(j);
                }
                return i;
            }
            else if (typeCast(IEnumerable$1_$type.specialize(Point_$type), c) !== null) {
                let l = c;
                let m = this.xa(a, b, PointCollectionUtil.b(l), d, e, f, g);
                let n = new List$1(FlattenedShape.$, 0);
                if (m != null) {
                    n.add(m);
                }
                return n;
            }
            else {
                throw new InvalidOperationException(1, "Unrecognized data in ShapeColumn");
            }
        }
        get_x4() {
            return true;
        }
        get x4() {
            return this.get_x4();
        }
        yd() {
            return false;
        }
        rq(a) {
            this.zl(this.cv);
        }
        ro(a, b, c, d, e) {
            super.ro(a, b, c, d, e);
            let f = this.ba.a$j.item(d);
            let g = f;
            f.a3(c);
            if (this.d5(f)) {
                return;
            }
            this.zl(f);
        }
        updateFillScaleGlobals() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.xt != null) {
                a.b = this.xt.minimum;
                a.a = this.xt.maximum;
            }
            if (this.w8 != null) {
                this.w8.z(a.b, a.a);
            }
        }
        zl(a) {
            if (this.d5(a)) {
                return;
            }
            if (this.w8 != null) {
                this.w4 = this.w5();
            }
            let b;
            let c;
            let d = a;
            let e = a.getViewInfo(c, b);
            c = e.p0;
            b = e.p1;
            if (c.width < 1 || c.height < 1 || this.xu == null) {
                return;
            }
            let f = this.xc;
            let g = this.xe;
            let h = this.getEffectiveViewport1(a);
            let i = new ScalerParams(1, b, c, f.ch);
            i.c = h;
            let j = new ScalerParams(1, b, c, g.ch);
            j.c = h;
            if (!this.gr) {
                d.cu();
                let k = new Rect(0, 0, 0, 0, 0);
                let l;
                let m;
                let n;
                let o;
                let p = this.xu.count;
                if (this.wz == null || this.wz.length != p) {
                    this.wz = new Array(p);
                    this.wx = new Array(p);
                    this.wy = new Array(p);
                    this.ww = new Array(p);
                }
                let q = this.wz;
                let r = this.wx;
                let s = this.wy;
                let t = this.ww;
                let u;
                for (let v = 0; v < p; v++) {
                    u = this.ye._inner[v];
                    q[v] = u.top;
                    r[v] = u.left;
                    s[v] = u.right;
                    t[v] = u.bottom;
                }
                this.xb.hq(boxArray$1(r), 0, r.length, i);
                this.xb.hq(boxArray$1(s), 0, s.length, i);
                this.xd.hq(boxArray$1(q), 0, q.length, j);
                this.xd.hq(boxArray$1(t), 0, t.length, j);
                d.cv(r, q, s, t);
                let w = this.xu;
                let x = this.dn;
                this.zo(d);
                let y = c.left;
                let z = c.right;
                let aa = c.top;
                let ab = c.bottom;
                let ac = null;
                if (this.z2.isEmpty) {
                    ac = null;
                }
                else {
                    ac = new Clipper(1, this.z2.left, this.z2.bottom, this.z2.right, this.z2.top, this.x4);
                }
                let ad = this.yd();
                if (ad) {
                    d.cc.clear();
                }
                let ae = false;
                let af = true;
                let ag = 0;
                if (this.db != null) {
                    if (this.db.f4()) {
                        let ah = this.db.m4(b, i);
                        ae = ah.c;
                        ag = ah.d;
                    }
                }
                let ai;
                for (let aj = 0; aj < p; aj++) {
                    n = r[aj];
                    l = q[aj];
                    m = t[aj];
                    o = s[aj];
                    k.x = Math.min(n, o);
                    k.y = Math.min(l, m);
                    k.width = Math.max(n, o) - k.x;
                    k.height = Math.max(l, m) - k.y;
                    if (k.intersectsWith(c)) {
                        if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                            ai = ac;
                        }
                        else {
                            ai = null;
                        }
                        let ak = this.yg(a, ai, w.item(aj), i, j, 0, ag);
                        if (ad) {
                            ShapeSeriesBase.zk(d, aj, ak);
                        }
                        d.ci(aj, x.item(aj), k, ak);
                    }
                    else if (ae) {
                        k.x = k.x + ag;
                        if (k.intersectsWith(c)) {
                            if (k.x < y || k.y < aa || k.x > z || k.y > ab) {
                                ai = ac;
                            }
                            else {
                                ai = null;
                            }
                            let al = this.yg(a, ai, w.item(aj), i, j, ag, ag);
                            if (ad) {
                                ShapeSeriesBase.zk(d, aj, al);
                            }
                            d.ci(aj, x.item(aj), k, al);
                        }
                    }
                }
                d.ct();
            }
            let am = this.yc();
            this.xj.az(this, this.yc(), runOn(this, this.w2));
            let an = false;
            let ao = this.xj.b;
            if (ao != null) {
                an = true;
            }
            let ap = a.q;
            let aq = this.fy;
            let ar = d.ca;
            d.cp((as) => {
                let at = as.dataContext != null ? as.dataContext.item : null;
                let au = as.dataContext != null ? as.dataContext.c : -1;
                d.cm(as, at, am);
                if (an) {
                    this.zh(as, aq, au, this.xu.count, ap, ar);
                }
                else {
                    if (ar) {
                        {
                            this.xj.a1(as, this.ib, ar);
                        }
                    }
                }
                {
                    this.xj.ad(as, false, false, false, false);
                }
            });
        }
        w5() {
            let a = new ActualRange();
            a.b = NaN;
            a.a = NaN;
            if (this.xt != null) {
                a.b = this.xt.minimum;
                a.a = this.xt.maximum;
            }
            let b = typeCast(ValueBrushScale.$, this.w8);
            if (b != null) {
                b.s();
                if (this.x1 && this.w8.o.count > 1) {
                    a.b = b.q;
                    a.a = b.p;
                }
            }
            return a;
        }
        zh(a, b, c, d, e, f) {
            let g = this.bx != 1;
            let h = this.cp != 1;
            let i = this.co != 1;
            this.xj.a0(this.xj.b, c, d, false);
            {
                this.xj.a1(a, this.ib, f);
            }
            let j = this.xj.ax;
            let k = null;
            let l = null;
            let m = null;
            let n = this.dn;
            if (this.xt != null && this.w8 != null) {
                if (j.z >= 0 && j.z < this.xt.count) {
                    let o = this.xt.item(j.z);
                    let p = this.w4;
                    let q = p.b;
                    let r = p.a;
                    let s = j.aa;
                    if (this.w9 != null) {
                        s = this.w9.getBrush1(j.z, this.xt.count);
                    }
                    else if (this.xl != null && this.xt != null) {
                        let t = this.xt.item(j.z);
                        s = this.xl.getBrushByRange(t, q, r);
                    }
                    else if (this.w8 != null) {
                        s = this.w8.getBrush(j.z);
                    }
                    j.aa = s;
                }
            }
            if (g && this.db != null) {
                k = this.db.dl.getHighlightingInfo(this, n, j.z, j.y, false);
                j.c = k;
            }
            if (h && this.db != null) {
                l = this.db.dm.getHighlightingInfo(this, n, j.z, j.y, false);
                if (l == null && this.bn != null) {
                    l = this.db.dm.getHighlightingInfo(this.bn, this.bn.dn, j.z, j.y, false);
                }
                if (l == null && this.bk != null) {
                    l = this.db.dm.getHighlightingInfo(this.bk, this.bk.dn, j.z, j.y, true);
                }
                j.d = l;
            }
            if (i && this.db != null) {
                m = this.db.dk.getHighlightingInfo(this, n, j.z, j.y, false);
                j.b = m;
            }
            j.h = e;
            this.zj(j);
            this.xj.z(this, k, l, m, e, g, h, i, false);
        }
        zg(a, b, c) {
            let d = this.bx != 1;
            let e = this.cp != 1;
            let f = this.co != 1;
            this.xj.a0(this.xj.d, a, b, true);
            this.xj.aa(this.ib);
            let g = this.xj.aw;
            let h = null;
            let i = null;
            let j = null;
            let k = this.dn;
            let l = null;
            let m = null;
            let n = null;
            if (d && this.db != null) {
                h = this.db.dl.getHighlightingInfo(this, k, g.z, g.y, true);
                if (this.db.dl.isCrossContextHighlight(this)) {
                    l = this.db.dl.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.c = h;
            }
            if (e && this.db != null) {
                i = this.db.dm.getHighlightingInfo(this, k, g.z, g.y, true);
                if (i == null && this.bn != null) {
                    i = this.db.dm.getHighlightingInfo(this.bn, this.bn.dn, g.z, g.y, true);
                }
                if (this.db.dm.isCrossContextHighlight(this)) {
                    m = this.db.dm.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.d = i;
            }
            if (f && this.db != null) {
                j = this.db.dk.getHighlightingInfo(this, k, g.z, g.y, true);
                if (this.db.dk.isCrossContextHighlight(this)) {
                    n = this.db.dk.getHighlightingInfo(this, k, g.z, g.y, true);
                }
                g.b = i;
            }
            g.h = c;
            this.zi(g);
            this.xj.y(this, h, i, j, c, d, e, f, g.v, this.db.dl.totalHighWaterMark, g.x, this.db.dm.totalHighWaterMark, g.t, this.db.dk.totalHighWaterMark);
        }
        zj(a) {
            if (this.assigningShapeStyle != null && this.xw) {
                this.assigningShapeStyle(this, a);
            }
        }
        zi(a) {
            if (this.assigningShapeMarkerStyle != null && this.xv) {
                this.assigningShapeMarkerStyle(this, a);
            }
        }
        w2(a, b) {
            return this.w3(a, b);
        }
        w3(a, b) {
            if (b < a || a < 0 || a > this.xu.count || b < 0 || b > this.xu.count) {
                return null;
            }
            let c = new Array((b - a) + 1);
            for (let d = a; d <= b; d++) {
                let e = d;
                c[d - a] = this.dn.item(d);
            }
            return c;
        }
        static zk(a, b, c) {
            let d = 0;
            let e = null;
            for (let f = 0; f < c.count; f++) {
                let g = c._inner[f];
                let h = g.b.width * g.b.height;
                if (h > d) {
                    d = h;
                    e = g;
                }
            }
            a.cc.addItem(b, e);
        }
        p9() {
            super.p9();
            if (this.xc != null) {
                this.xc.ia();
            }
            if (this.xe != null) {
                this.xe.ia();
            }
        }
        sp(a, b) {
            this.rp(false);
        }
        so(a, b) {
            this.rp(false);
        }
        pb(a, b, c, d) {
            super.pb(a, b, c, d);
            switch (a) {
                case 3:
                    if (d == this.y5) {
                        this.ye._inner[b] = this.z3(this.xu.item(b));
                    }
                    break;
                case 1:
                    for (let e = b; e < b + c; e++) {
                        this.ye.insert(e, this.z3(this.xu.item(e)));
                    }
                    break;
                case 0:
                    this.ye.v(b, c);
                    break;
                case 2:
                    for (let f = b; f < b + c; f++) {
                        this.ye._inner[f] = this.z3(this.xu.item(f));
                    }
                    break;
                case 4:
                    this.zm();
                    break;
            }
            this.rp(false);
        }
        he(a, b, c) {
            let d = true;
            if (!super.he(a, b, c) || (this.x8 && this.xu == null) || b.isEmpty || a.isEmpty || this.xc == null || this.xe == null || this.xc.bi == null || this.xe.bi == null || this.xc.l4 == this.xc.l3 || this.xe.l4 == this.xe.l3 || this.xu == null || this.xu.count == 0 || this.ye == null || this.ye.count == 0 || this.ye.count != this.xu.count) {
                d = false;
            }
            return d;
        }
        get_x8() {
            return true;
        }
        get x8() {
            return this.get_x8();
        }
        qz(a) {
            super.qz(a);
            this.xk = typeCast(ShapeSeriesViewBase.$, a);
        }
        yh(a, b, c, d, e, f, g) {
            let h = new List$1(FlattenedShape.$, 0);
            let i;
            let j = c.count;
            for (let k = 0; k < j; k++) {
                i = c._inner[k];
                let l = this.xa(a, b, i, d, e, f, g);
                if (l == null) {
                    continue;
                }
                h.add(l);
            }
            return h;
        }
        xa(a, b, c, d, e, f, g) {
            let h = this.zc(c, d, e);
            let i = h.c;
            let j = h.d;
            let k = i.length;
            let l = 1.7976931348623157E+308;
            let m = 1.7976931348623157E+308;
            let n = -1.7976931348623157E+308;
            let o = -1.7976931348623157E+308;
            let p;
            let q;
            if (f != 0) {
                for (let r = 0; r < k; r++) {
                    i[r] = i[r] + f;
                }
            }
            for (let s = 0; s < k; s++) {
                p = i[s];
                q = j[s];
                l = p < l ? p : l;
                m = q < m ? q : m;
                n = p > n ? p : n;
                o = q > o ? q : o;
            }
            let t = !(l > this.z2.right || n < this.z2.left || m > this.z2.bottom || o < this.z2.top);
            if (!t && f == 0 && g != 0) {
                if (g != 0) {
                    for (let u = 0; u < k; u++) {
                        i[u] = i[u] + g;
                    }
                }
                for (let v = 0; v < k; v++) {
                    p = i[v];
                    q = j[v];
                    l = p < l ? p : l;
                    m = q < m ? q : m;
                    n = p > n ? p : n;
                    o = q > o ? q : o;
                }
                t = !(l > this.z2.right || n < this.z2.left || m > this.z2.bottom || o < this.z2.top);
            }
            if (!t) {
                return null;
            }
            let w = b != null && (l < this.z2.left || m < this.z2.top || n > this.z2.right || o > this.z2.bottom);
            let x = new Rect(0, l, m, n - l, o - m);
            if (!a.cb(x)) {
                return null;
            }
            l = l < this.z2.left ? this.z2.left : l;
            n = n > this.z2.right ? this.z2.right : n;
            m = m < this.z2.top ? this.z2.top : m;
            o = o > this.z2.bottom ? this.z2.bottom : o;
            let y = PolySimplification.b(h, this.id);
            let z = new DefaultFlattener().c(h.c, h.d, y, this.yi);
            let aa = z.count;
            if (w) {
                let ab = new List$1(Point_$type, 0);
                b.i = ab;
                for (let ac = 0; ac < aa; ac++) {
                    b.j(z._inner[ac]);
                }
                b.i = null;
                z = ab;
            }
            if (z == null || z.count == 0) {
                return null;
            }
            let ad = new FlattenedShape();
            ad.a = z;
            ad.b = new Rect(0, l, m, n - l, o - m);
            ad.c = x;
            return ad;
        }
        zc(a, b, c) {
            let d = this.xb;
            let e = this.xd;
            let f = a.count;
            let g = new Array(f);
            let h = new Array(f);
            for (let i = 0; i < f; i++) {
                g[i] = a._inner[i].x;
                h[i] = a._inner[i].y;
            }
            d.hq(boxArray$1(g), 0, g.length, b);
            e.hq(boxArray$1(h), 0, h.length, c);
            return new Tuple$2(Array_$type, Array_$type, g, h);
        }
        zo(a) {
            a.c0();
        }
        o5(a, b) {
            super.o5(a, b);
            let c = b;
            c.cn();
        }
        zf(a) {
            if (a != null) {
                a.ct(this);
            }
        }
        zn(a) {
            if (a != null) {
                a.b0(this);
            }
        }
        zd(a, b, c) {
            let d = this.cv;
            let e = d.bx;
            let f = this.wp(a);
            if (e.width < 1 || e.height < 1 || this.xu == null) {
                return;
            }
            let g = this.getEffectiveViewport1(d);
            let h = new ScalerParams(0, f, e, this.xc.ch, g);
            let i = new ScalerParams(0, f, e, this.xe.ch, g);
            d.cu();
            let j = this.xu.count;
            let k = new Array(j);
            let l = new Array(j);
            let m = new Array(j);
            let n = new Array(j);
            let o;
            for (let p = 0; p < j; p++) {
                o = this.ye._inner[p];
                k[p] = o.top;
                l[p] = o.left;
                m[p] = o.right;
                n[p] = o.bottom;
            }
            this.xc.hq(boxArray$1(l), 0, l.length, h);
            this.xc.hq(boxArray$1(m), 0, m.length, h);
            this.xe.hq(boxArray$1(k), 0, k.length, i);
            this.xe.hq(boxArray$1(n), 0, n.length, i);
            d.cv(l, k, m, n);
            d.c0();
            let q = null;
            if (!this.z2.isEmpty) {
                q = new Clipper(1, this.z2.left, this.z2.bottom, this.z2.right, this.z2.top, this.x4);
            }
            let r = false;
            let s = 0;
            if (this.db != null) {
                if (this.db.f4()) {
                    let t = this.db.m4(f, h);
                    r = t.c;
                    s = t.d;
                }
            }
            let u, v, w, x;
            let y = new Rect(0, 0, 0, 0, 0);
            for (let z = 0; z < j; z++) {
                w = l[z];
                u = k[z];
                v = n[z];
                x = m[z];
                y.x = Math.min(w, x);
                y.y = Math.min(u, v);
                y.width = Math.max(w, x) - y.x;
                y.height = Math.max(u, v) - y.y;
                if (r) {
                    y.x = y.x + s;
                }
                if (!y.intersectsWith(e)) {
                    continue;
                }
                let aa = this.yg(d, q, this.xu.item(z), h, i, s, s);
                if (aa.count <= 0) {
                    continue;
                }
                this.xx(b, c, z);
            }
        }
        xx(a, b, c) {
            if (b == 7 || b == 6) {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.series = this;
                    return $ret;
                })()));
                return false;
            }
            else if (b == 1 || b == 2) {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dn.item(c);
                    return $ret;
                })()));
                return true;
            }
            else {
                a.add(((() => {
                    let $ret = new ChartSelection();
                    $ret.item = this.dn.item(c);
                    $ret.series = this;
                    return $ret;
                })()));
                return true;
            }
        }
        a2(a, b) {
            let c = this.xk.c2(a, b);
            let d = null;
            if (c != null) {
                d = c.dataContext;
            }
            if (d != null) {
                return d;
            }
            return super.a2(a, b);
        }
        yp(a) {
            return this.dn.item(a);
        }
        get_g7() {
            return true;
        }
        set_g7(a) {
            super.set_g7(a);
        }
        ay(a) {
            if (typeCast(NumericXAxis.$, a) !== null && this.ye != null) {
                let b = 1.7976931348623157E+308;
                let c = -1.7976931348623157E+308;
                for (let d of fromEnum(this.ye)) {
                    b = Math.min(b, d.left);
                    c = Math.max(c, d.right);
                }
                return new AxisRange(b, c);
            }
            if (typeCast(NumericYAxis.$, a) !== null && this.ye != null) {
                let e = 1.7976931348623157E+308;
                let f = -1.7976931348623157E+308;
                for (let g of fromEnum(this.ye)) {
                    e = Math.min(e, g.top);
                    f = Math.max(f, g.bottom);
                }
                return new AxisRange(e, f);
            }
            return null;
        }
        get_fx() {
            return true;
        }
        get_fl() {
            return true;
        }
        get x2() {
            return this.styleShape != null;
        }
        z4(a, b, c) {
            if (this.styleShape != null) {
                if (this.xk.c9 != null && c == this.xk.c9) {
                    c = new Style();
                    let d = this.xk.c9;
                    c.fill = d.fill;
                    c.opacity = d.opacity;
                    c.stroke = d.stroke;
                    c.strokeThickness = d.strokeThickness;
                }
                else {
                    if (c != null) {
                        let e = new Style();
                        e.fill = c.fill;
                        e.opacity = c.opacity;
                        e.stroke = c.stroke;
                        e.strokeThickness = c.strokeThickness;
                        c = e;
                    }
                    else {
                        c = new Style();
                    }
                }
                let f = new StyleShapeEventArgs(a, b, c);
                this.styleShape(this, f);
                return f.d();
            }
            return c;
        }
    }
    ShapeSeriesBase.$t = /*@__PURE__*/ markType(ShapeSeriesBase, 'ShapeSeriesBase', Series.$, [ISupportsFillScale_$type]);
    ShapeSeriesBase.zs = /*@__PURE__*/ DependencyProperty.i("HighlightedValueMemberPath", String_$type, ShapeSeriesBase.$, /*@__PURE__*/ new PropertyMetadata(2, null, (a, b) => a.raisePropertyChanged("HighlightedValueMemberPath", b.oldValue, b.newValue)));
    ShapeSeriesBase.$$p = /*@__PURE__*/ markDep(DependencyProperty, PropertyMetadata, ShapeSeriesBase, 'raisePropertyChanged', ['FillMemberPath:ys:zp', [2], 'FillScale:w8:zq', [BrushScale.$], 'FillScaleUseGlobalValues:x1:zr', [0, false], 'IsCustomShapeMarkerStyleAllowed:x5:zt', [0, false], 'IsCustomShapeStyleAllowed:x6:zu', [0, false], 'ItemSearchMode:xi:zv', [ShapeItemSearchMode_$type, /*@__PURE__*/ enumGetBox(ShapeItemSearchMode_$type, 0)], 'ItemSearchPointsThreshold:yn:zw', [1, 10000], 'ItemSearchThreshold:yo:zx', [1, 10000], 'ShapeFilterResolution:yk:zy', [1, 2], 'ShapeMemberPath:y5:zz', [2, null], 'XAxis:xc:z0', [NumericXAxis.$, null], 'YAxis:xe:z1', [NumericYAxis.$, null]]);
    return ShapeSeriesBase;
})();
/**
 * @hidden
 */
export let ShapeSeriesRenderManager = /*@__PURE__*/ (() => {
    class ShapeSeriesRenderManager extends SeriesRenderManager {
        constructor() {
            super(...arguments);
            this.aw = null;
            this.ax = null;
        }
        c() {
            this.aw = new AssigningShapeMarkerStyleEventArgs();
            return this.aw;
        }
        a() {
            this.ax = new AssigningShapeStyleEventArgs();
            return this.ax;
        }
        a1(a, b, c) {
            this.ag = this.ak;
            this.ah = this.al;
            this.m = this.t;
            this.am = this.an;
            this.ao = this.ar;
            this.k = this.r;
            this.l = this.s;
            this.j = this.q;
            if (c) {
                if (a._fill != null) {
                    this.ag = a._fill;
                }
                if (a._stroke != null) {
                    this.ah = a._stroke;
                }
                if (!isNaN_(a.ad) && (a.y == null || !isNaN_(a.y.strokeThickness))) {
                    this.m = a.ad;
                }
            }
            let d = this.b;
            if (d != null) {
                d.aa = this.ag;
                d.ab = this.ah;
                d.ae = this.m;
                d.af = this.am;
                d.ag = this.ao;
                d.ac = this.k;
                d.ad = this.l;
                d.o = this.j;
                d.g = this.f;
                d.k = b;
                d.f = false;
            }
        }
        ay(a, b, c) {
            this.w(a, b, c);
        }
        az(a, b, c) {
            this.x(a, b, c);
        }
        a0(a, b, c, d) {
            if (b == -1) {
                a.e = false;
                a.z = 0;
                a.y = c - 1;
            }
            else {
                if (d) {
                    a.z = b;
                    a.y = b;
                }
                else {
                    a.e = false;
                    a.z = b;
                    a.y = b;
                }
            }
        }
    }
    ShapeSeriesRenderManager.$t = /*@__PURE__*/ markType(ShapeSeriesRenderManager, 'ShapeSeriesRenderManager', SeriesRenderManager.$);
    return ShapeSeriesRenderManager;
})();
/**
 * @hidden
 */
export let ShapeSeriesViewBase = /*@__PURE__*/ (() => {
    class ShapeSeriesViewBase extends SeriesView {
        constructor(a) {
            super(a);
            this.cc = null;
            this.b6 = null;
            this.cd = new List$1(ShapeHitRegion.$, 0);
            this.ch = 0;
            this.cg = null;
            this.b9 = null;
            this.c7 = new Path();
            this.b7 = null;
            this.c8 = null;
            this.b1 = null;
            this.b3 = null;
            this.b2 = null;
            this.b0 = null;
            this.b6 = a;
            this.b9 = this.b8();
            this.cg = new List$1(Path.$, 0);
            this.cc = new Dictionary$2(Number_$type, FlattenedShape.$, 0);
        }
        b4(a) {
            return null;
        }
        get ce() {
            return this.cd;
        }
        b8() {
            return ((() => {
                let $ret = new Pool$1(FrameworkElement.$);
                $ret.create = runOn(this, this.c1);
                $ret.activate = runOn(this, this.cq);
                $ret.disactivate = runOn(this, this.cr);
                $ret.destroy = runOn(this, this.cs);
                return $ret;
            })());
        }
        cb(a) {
            return a.width >= this.b6.yl && a.height >= this.b6.yl;
        }
        static cf(a) {
            let b = new List$1(PointCollection.$, 0);
            let c;
            let d = a.count;
            for (let e = 0; e < d; e++) {
                c = a._inner[e];
                let f = new PointCollection(1, c.a);
                b.add(f);
            }
            return b;
        }
        get ca() {
            return this.c8 != null || this.b7 != null || this.b6.x2;
        }
        ci(a, b, c, d) {
            if (d != null && d.count > 0) {
                let e = ShapeSeriesViewBase.cf(d);
                c.intersect(this.bx);
                if (!this.cb(c)) {
                }
                else {
                    let f = this.c5(a, e);
                    if (f != null) {
                        let g = this.c4(this.ch, b);
                        for (let h = 0; h < d.count; h++) {
                            let i = new ShapeHitRegion();
                            i.d = d._inner[h].b;
                            i.a = d._inner[h].a;
                            i.b = a;
                            i.c = g;
                            this.cd.add(i);
                        }
                        this.ck(g, f);
                        this.ch = this.ch + 1;
                    }
                }
            }
        }
        c4(a, b) {
            let c = this.b9.item(this.ch);
            if (c.dataContext != null) {
                c.dataContext.item = b;
                c.dataContext.c = a;
            }
            return c;
        }
        static cl(a, b, c) {
            if (b._fill == null) {
                b._fill = a.e.u7;
            }
            if (b._stroke == null) {
                b._stroke = a.e.vb;
            }
            if (b.y == null) {
                b.ad = a.e.ie;
            }
        }
        cp(a) {
            for (let b = 0; b < this.b9.a.count; b++) {
                let c = this.b9.a._inner[b];
                a(c);
            }
        }
        cm(a, b, c) {
            if (a == null) {
                return;
            }
            this.co(a, c);
            let d = false;
            if (this.b7 != null) {
                let e = this.b7.selectStyle(b, a);
                if (e != null) {
                    d = true;
                }
                if (a.y != e) {
                    a.y = e;
                    this.k.j(a, a.y);
                }
            }
            if (!d) {
                if (a.y != this.c8) {
                    a.y = this.c8;
                    this.k.j(a, a.y);
                }
            }
            let f = this.b6.z4(b, a, a.y);
            if (a.y != f) {
                a.y = f;
                this.k.j(a, a.y);
            }
        }
        co(a, b) {
        }
        cj(a, b) {
            let c = truncate(Math.floor(a.left));
            let d = truncate(Math.ceil(a.right));
            let e = truncate(Math.floor(a.top));
            let f = truncate(Math.ceil(a.bottom));
            for (let g = c; g < d; g++) {
                for (let h = e; h < f; h++) {
                    this.cx(g, h, b);
                }
            }
        }
        cx(a, b, c) {
        }
        cu() {
            this.ch = 0;
        }
        ct() {
            this.b9.count = this.ch;
            this.as();
        }
        cw(a, b) {
        }
        cn() {
            this.b9.count = 0;
            this.as();
        }
        c1() {
            let a = this.b6;
            let b = ((() => {
                let $ret = new Path();
                $ret.dataContext = ((() => {
                    let $ret = new DataContext();
                    $ret.series = a;
                    return $ret;
                })());
                return $ret;
            })());
            this.cg.add(b);
            return b;
        }
        cq(a) {
            a._visibility = 0;
        }
        cr(a) {
            a.dataContext.item = null;
            a._visibility = 1;
        }
        cs(a) {
            this.cg.remove(a);
        }
        c6(a, b, c) {
            if (b == null) {
                return null;
            }
            let d = new PathGeometry();
            let e;
            let f = b.count;
            for (let g = 0; g < f; g++) {
                e = b._inner[g];
                if (e.count < 1) {
                    continue;
                }
                let h = new PolyLineSegment();
                h._points = e;
                let i = new PathFigure();
                i._isFilled = c;
                i._isClosed = c;
                i._startPoint = e._inner[0];
                i._segments.add(h);
                d.c.add(i);
            }
            return d;
        }
        ac(a) {
            return this.cg._inner[a];
        }
        ab(a) {
            let b = this.cg._inner[a];
            this.c7._visibility = b._visibility;
            this.c7.an = b.an;
            let c = this.bs(a);
            this.c7._fill = c;
            this.c7._stroke = c;
            this.c7.ad = this.e.ie + 3;
            return this.c7;
        }
        a8(a, b) {
            super.a8(a, b);
            for (let c = 0; c < this.cg.count; c++) {
                let d = this.aa(c, b);
                if (d._visibility != 1) {
                    a.t(d);
                }
            }
        }
        get c9() {
            return this.c8;
        }
        cz(a) {
            this.b7 = a;
        }
        cy(a) {
            this.c8 = a;
        }
        c2(a, b) {
            return this.c3(a, b, false);
        }
        c3(a, b, c) {
            let d = this.b5(a, b, c);
            if (d == null) {
                return null;
            }
            return d.c;
        }
        b5(a, b, c) {
            if (this.cd.count == 0) {
                return null;
            }
            let d = a.x;
            let e = a.y;
            let f = this.cd.count;
            let g = this.cd;
            let h = null;
            for (let i = 0; i < f; i++) {
                h = g._inner[i];
                if (h.a == null || h.a.count == 0) {
                    continue;
                }
                if (d >= h.d.left && d <= h.d.right && e >= h.d.top && e <= h.d.bottom) {
                    if (c) {
                        let j = this.b6.ie / 2 + this.b6.iu(b);
                        if (GeometryUtil.e(a, h.a._inner[0], h.a, j)) {
                            return h;
                        }
                    }
                    else {
                        if (PolygonUtil.b(h.a, a)) {
                            return h;
                        }
                    }
                }
            }
            return null;
        }
        cv(a, b, c, d) {
            this.b1 = a;
            this.b3 = b;
            this.b2 = c;
            this.b0 = d;
            this.cd.clear();
        }
        c0() {
            let a = this.bx;
            let b = ((() => {
                let $ret = new Path();
                $ret.y = this.c8;
                return $ret;
            })());
            b.ad = 1;
            if (this.k != null) {
                this.k.j(b, b.y);
            }
            this.b6.z2 = RectUtil.r(a, b.ad);
        }
        an(a) {
            super.an(a);
            if (this.b9.a == null) {
                return;
            }
            for (let b = 0; b < this.b9.a.count; b++) {
                let c = typeCast(Path.$, this.b9.a._inner[b]);
                if (c._visibility != 1) {
                    this.e.bc.exportPathData(a, c, "shape" + b, ["Main "]);
                }
            }
        }
    }
    ShapeSeriesViewBase.$t = /*@__PURE__*/ markType(ShapeSeriesViewBase, 'ShapeSeriesViewBase', SeriesView.$);
    return ShapeSeriesViewBase;
})();
